import fetch from 'isomorphic-fetch';
import actionType from '../actiontype/common'
import {saveHeaderInfo} from "./initHeader";
import actionTypes from "../actiontype/user";
const domain = ENV.domain;
//获取工单


let myHeaders = new Headers({
    'Access-Control-Allow-Origin': '*',
    // 'Content-Type': 'text/plain;charset=UTF-8',
    // 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
    'Content-Type': 'application/json; charset=UTF-8',
});




//测试使用的数据
let testData={
    "meta": {
        "code": "200",
        "message": "成功",
        "success": true
    },
    "data": {
        "whetherType": false,
        "taskId": 297,
        "currentTaskName": "遗留上报任务",
        "currentTaskType": "LR",
        "currentTaskNum": 2,
        "totalTaskNum": 3
    }
}
let test='http://192.168.10.128:8080/'

//开始工作
const getTaskInfo = (data)=>{
    // let {employeeId,storeId} = data;
    // let url = `${test}web/flat/ready${storeId}/${employeeId}`
    let url=`${test}web/flat/ready/16/2`;
    return(dispatch)=>{
        // let taskInfo=testData.data;
        // dispatch(startalljob(Object.assign({},{taskInfo})))
        fetch(url,{
            credentials : 'include',
            method : 'GET',
            mode : 'cors',
            headers: { 'Content-Type': 'application/json' },
        }).then((response)=>response.json())
            .then(json=>{
                let taskInfo=Object.assign({});
                console.log(json,'开始工作')
                if(json.meta.success && json.data){
                    taskInfo = Object.assign({},json.data)
                }
                console.log(taskInfo)
                dispatch(saveCommonInfo(Object.assign({},taskInfo)))
                dispatch(startalljob(Object.assign({},{taskInfo})))
            }).catch(e=>{console.error(e)})

    }
};

//获取店铺信息
const getStoreInfo = (storeId)=>{
    return(dispatch)=>{
        let bodyData = {storeId};
        fetch(domain + 'pad_warehouse/getMachineData.action',{
            credentials : 'include',
            method : 'POST',
            mode : 'cors',
            headers: { 'Content-Type': 'application/json' },
            body: JSON.stringify(bodyData)
        }).then((response)=>response.json())
            .then(json=>{
                let storeInfo = Object.assign({},{id:storeId});
                if(json.meta.success && json.data.warehouse){
                    storeInfo = Object.assign({},storeInfo,json.data.warehouse)
                }
                dispatch(saveCommonInfo(Object.assign({},{storeInfo})))
            }).catch(e=>{console.error(e)})


    }
};

//获取条形码信息

const getInfoByBarcode = (data)=>{
    let {storeId,barcode} = data;
    let url = `flat/barcode/${storeId}/${barcode}`
    return (dispatch)=>{
        // dispatch(clearBarcodeInfo()); //清空barcode信息
        fetch(domain + url,{
            credentials : 'include',
            method : 'GET',
            mode : 'cors',
            headers: { 'Content-Type': 'application/json' }
        }).then(response=>response.json())
            .then(json=>{
                console.log(json);
                if(json.meta.success){
                    //扫码成功
                }else{
                    //扫码失败
                }
            })
    }
};

//获取用户信息
const getUserinfo = (employeeId,storeId)=>{
    let bodyData = Object.assign({},{employeeId,storeId})
    return(dispatch)=>{
        dispatch(saveHeaderInfo(info));
        fetch(domain + 'machine_pad/get_alowed_task.action',{
            credentials : 'include',
            method : 'POST',
            mode : 'cors',
            headers:myHeaders,
            body : JSON.stringify(bodyData)
        }).then((response)=>response.json())
            .then(json=>{
                let userInfo = Object.assign({},{id:employeeId})
                if(json.meta.success && json.data){
                    if(json.data.employee){
                        userInfo = Object.assign({},userInfo,json.data.employee)
                    }
                    if(json.data.type){
                        userInfo = Object.assign({},userInfo,{taskType:json.data.type});
                    }else{
                        dispatch(addErrorInfo('没有任务需要处理'))
                    }
                    dispatch(saveCommonInfo(Object.assign({},{userInfo})));
                }
            }).catch(e=>{console.error(e)})
    }
};

const test = ()=>{
    fetch('http://192.168.10.128:8080/web/flat/work/status/1',{
        credentials : 'include',
        method : 'PUT',
        mode : 'cors',
        headers:myHeaders,
    }).then((response)=>response.json())
        .then(json=>{
            console.log(json)
        }).catch(e=>{console.error(e)})
}

//拉取工单
const getTaskList = (data)=>{
    console.log('拉取工单')
    console.log(data)
//    let storeId = data.id;
   let url=`${test}web/flat/work/list/16`
    return (dispatch)=>{
         fetch(url,{
            credentials : 'include',
            method : 'GET',
            mode : 'cors',
            headers: { 'Content-Type': 'application/json' }
         }).then((reponse)=>response.json())
         .then((json)=>{
             console.log(json,'拉取工单')   
            let taskList=Object.assign({})
                if(json.meta.success && json.data){
                    taskList = Object.assign({},json.data)
                }
                dispatch(saveTaskListInfo(Object.assign({},{taskList})))
         })
    }
}

const saveTaskListInfo = (data)=>{
    return{
        type : actionType.GETTASKLIST,
        data
    }
}

const setBarcodeInfo = (data)=>{
    return{
        type : actionType.SETBARCODEINFO,
        data
    }
};

const clearBarcodeInfo = (data)=>{
    return{
        type : actionType.EMPTYBARCODEINFO,
        data
    }
};

const saveCommonInfo = (data)=>{
    return {
        type : actionType.SAVECOMMONINFO,
        data
    }
};
const startalljob=(data)=>{
    return {
        type: actionType.STARTALLJOB,
        data
    }
}
const logout = ()=>{
    let data = Object.assign({},{userInfo:{},taskInfo:{}});
    return {
        type : actionTypes.EMPTYCOMMONINFO,
        data
    }
}

export {getStoreInfo,getTaskInfo,getInfoByBarcode,saveCommonInfo,getUserinfo,logout,startalljob,saveTaskListInfo,getTaskList}
